# Class CreateStaticLibrary

java.lang.Object
org.gradle.api.internal.AbstractTask
org.gradle.api.DefaultTask
org.gradle.nativeplatform.tasks.CreateStaticLibrary

All Implemented Interfaces:
  `Comparable<Task>, org.gradle.api.internal.DynamicObjectAware, org.gradle.api.internal.TaskInternal, ExtensionAware, Task, ObjectFilesToBinary, org.gradle.util.Configurable<Task>`

@Incubating public class CreateStaticLibrary extends DefaultTask implements ObjectFilesToBinary
Assembles a static library from object files.

## Nested Class Summary

### Nested classes/interfaces inherited from interface Task

`Task.Namer`

## Field Summary

### Fields inherited from interface Task

`TASK_ACTION, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

## Constructor Summary

Constructors
Constructor
Description
`CreateStaticLibrary()`

## Method Summary

Modifier and Type
Method
Description
`org.gradle.internal.operations.logging.BuildOperationLoggerFactory`
`getOperationLoggerFactory()`
`File`
`getOutputFile()`
The file where the output binary will be located.
`FileCollection`
`getSource()`
The source object files to be passed to the archiver.
`List<String>`
`getStaticLibArgs()`
Additional arguments passed to the archiver.
`NativePlatform`
`getTargetPlatform()`
The platform being targeted.
`NativeToolChain`
`getToolChain()`
The tool chain used for creating the static library.
`void`
`link()`
`void`
`setOutputFile(File outputFile)`
`void`
`setStaticLibArgs(List<String> staticLibArgs)`
`void`
`setTargetPlatform(NativePlatform targetPlatform)`
`void`
`setToolChain(NativeToolChain toolChain)`
`void`
`source(Object source)`
Adds a set of object files to be linked.

### Methods inherited from class DefaultTask

`newInputDirectory, newInputFile, newOutputDirectory, newOutputFile`

### Methods inherited from class org.gradle.api.internal.AbstractTask

`addValidator, appendParallelSafeAction, compareTo, configure, deleteAllActions, dependsOn, dependsOnTaskDidWork, doFirst, doFirst, doFirst, doLast, doLast, doLast, execute, finalizedBy, getActions, getAnt, getAsDynamicObject, getConvention, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExecuter, getExtensions, getFinalizedBy, getGroup, getIdentityPath, getImpliesSubProjects, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOnlyIf, getOutputs, getPath, getProject, getServices, getShouldRunAfter, getStandardOutputCapture, getState, getTaskActions, getTaskDependencies, getTemporaryDir, getTemporaryDirFactory, getValidators, hasProperty, injectIntoNewInstance, isEnabled, isHasCustomActions, leftShift, mustRunAfter, onlyIf, onlyIf, prependParallelSafeAction, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setExecuter, setFinalizedBy, setGroup, setImpliesSubProjects, setMustRunAfter, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, toString`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface Comparable

`compareTo`

### Methods inherited from interface ExtensionAware

`getExtensions`

### Methods inherited from interface Task

`configure, deleteAllActions, dependsOn, dependsOnTaskDidWork, doFirst, doFirst, doFirst, doLast, doLast, doLast, finalizedBy, getActions, getAnt, getConvention, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getFinalizedBy, getGroup, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getPath, getProject, getShouldRunAfter, getTaskDependencies, getTemporaryDir, hasProperty, leftShift, mustRunAfter, onlyIf, onlyIf, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setFinalizedBy, setGroup, setMustRunAfter, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter`

## Constructor Details

### CreateStaticLibrary

public CreateStaticLibrary()

## Method Details

### getSource

@InputFiles @SkipWhenEmpty public FileCollection getSource()
The source object files to be passed to the archiver.

### source

public void source(Object source)
Adds a set of object files to be linked.

The provided source object is evaluated as per `Project.files(Object...)`.

Specified by:
  `source` in interface `ObjectFilesToBinary`

### getOperationLoggerFactory

@Inject public org.gradle.internal.operations.logging.BuildOperationLoggerFactory getOperationLoggerFactory()

### link

public void link()

### getToolChain

@Internal public NativeToolChain getToolChain()
The tool chain used for creating the static library.

### setToolChain

public void setToolChain(NativeToolChain toolChain)

### getTargetPlatform

public NativePlatform getTargetPlatform()
The platform being targeted.

### setTargetPlatform

public void setTargetPlatform(NativePlatform targetPlatform)

### getOutputFile

@OutputFile public File getOutputFile()
The file where the output binary will be located.

### setOutputFile

public void setOutputFile(File outputFile)

### getStaticLibArgs

@Input public List<String> getStaticLibArgs()
Additional arguments passed to the archiver.

### setStaticLibArgs

public void setStaticLibArgs(List<String> staticLibArgs)